#include <sys/types.h>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

string convertInt(int number)
{
	string temp = "", returnvalue = "";

	if(number == 0)
		return "0";

	while(number > 0) {
		temp += number % 10 + 48;
		number /= 10;
	}

	for(unsigned int i=0; i < temp.length(); i++)
		returnvalue += temp[temp.length() - i - 1];

	return returnvalue;
}

int main(int argc, char* argv[])
{
	unsigned long period_ms, period_us, usage_us;
	int task_sets;
	double utilization, task_util, usage_cap;
	string line, name;
	ofstream outputfile;

	if(argc != 3) {
		cout << "Run with baker_medium_uniform [utilization_cap] [task sets]" << endl;
		return 0;
	}

	srand ( time(NULL) );

	usage_cap = strtod(argv[1], NULL);
	task_sets = atoi(argv[2]);

	for(int i = 0; i < task_sets; i++) {
		utilization = 0;
		name.erase();
		name.append("bmu_");
		name.append(convertInt((int)usage_cap * 100));
		name.append("_");
		name.append(convertInt(i));
		outputfile.open(name.c_str());
		outputfile << "#Baker Medium/Uniform Taskset with Utilization of " << usage_cap << endl;
		outputfile << "#The number of locks" << endl << "L	0" << endl;
		outputfile << "#The tasks" << endl;
		outputfile << "#	CPUs	Period (us)	Usage (us)	Utility	Locks	HUA Ut." << endl;

		while(utilization < usage_cap) {
			/* Generate task information */
			period_ms = rand() % 100;
			period_us = period_ms * 1000;

			/* Validate period is between 10ms and 100ms*/
			if(period_ms < 10)
				continue;

			/* Find a valid usage */
			do {
				usage_us = rand() % (400 * period_ms);
			} while(usage_us < (100 * period_ms));

			task_util = (double)usage_us/(1000*period_ms);

			/* Quit if we've overrun the utilization */
			utilization += task_util;
			if(utilization > usage_cap)
				continue;

			outputfile << "T	all	";
			outputfile << period_us << "	" << usage_us << endl;
//			cout << "Task has period " << period_ms << " ms, execution " << usage_us << " us, usage " << task_util << endl;
		}

		outputfile.close();
	}

	return 0;
}

