#!/usr/bin/perl

use strict;
use warnings;

my $find = "all";
my $count;
my @load;
my $taskload;
my $cpu;
my $low_cpu;
my $numArgs = $#ARGV + 1;
my $filecount;

if($numArgs < 2)
{
	print "$numArgs\n";
	die $!;
}

for ($filecount = 1; $filecount < $numArgs; $filecount++) {
	my %lines;
	for ($count = 0; $count < $ARGV[0]; $count++) {
		$load[$count] = 0;
	}

	$count = 0;
	open FILE, "$ARGV[$filecount]" or die $!;
	my $filename = ">" . $ARGV[$filecount] . "_part";
	my $opened = open NEWFILE, $filename;

	if( ! $opened ){
		print "Error!";
		close FILE;
		exit 1;
	}

	while (my $line = <FILE>) {
		if($count > 4) {
			my @values = split(' ',$line);
			$taskload = $values[3]/$values[2];
			$lines{$line} = $taskload;
		} else {
			print NEWFILE "$line";
		}

		$count++;
	}

	foreach my $line (sort {$lines{$b} <=> $lines{$a}} keys %lines) {
		my @values = split(' ',$line);
		$taskload = $values[3]/$values[2];

		$low_cpu = 0;
		for ($cpu = 0; $cpu < $ARGV[0]; $cpu++) {
			if($load[$cpu] < $load[$low_cpu]) {
				$low_cpu = $cpu;
			}
		}

		$load[$low_cpu] += $taskload;
		$line =~ s/$find/$low_cpu/g;

		print NEWFILE "$line";
	}

	close NEWFILE;
	close FILE;
}

exit 0;

