#include "test.h"

unsigned long mask1 = 1, mask2 = 2, mask3 = 3;
struct timespec period;

void *task1(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask1), (cpu_set_t *) &mask1);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	test_val *= 7;
	period.tv_sec = 2;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	burn_cpu(100000, exec_slope);
	test_val -= 9;
	burn_cpu(1900000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val -= 17;
	pthread_exit(NULL);
}

void *task2(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask1), (cpu_set_t *) &mask1);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	test_val *= 11;
	period.tv_sec = 1;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	burn_cpu(1000000, exec_slope);
	test_val -= 13;
	burn_cpu(1000000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val *= 15;
	pthread_exit(NULL);
}

void *task3(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask2), (cpu_set_t *) &mask2);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	test_val *= 7;
	period.tv_sec = 2;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	burn_cpu(200000, exec_slope);
	test_val -= 9;
	burn_cpu(1800000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val -= 17;
	pthread_exit(NULL);
}

void *task4(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask2), (cpu_set_t *) &mask2);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	test_val *= 11;
	period.tv_sec = 1;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	burn_cpu(1000000, exec_slope);
	test_val -= 13;
	burn_cpu(1000000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val *= 15;
	pthread_exit(NULL);
}

int main(int argc, char* argv[])
{
	pthread_t t1, t2, t3, t4;
	char c, optstring[]= "vh";
	int proc_count = 1;

	sched = SCHED_RT_RMA;

	while ((c = getopt (argc, argv, optstring)) != -1)
	{
		switch (c) {
		case 'v' :
			verbose = true;
			break;
		case 'h' :
			cout << "A simple test for proper partitioned scheduling behavior. Use -v for detailed output" << endl;
			return 0;
		}
	}

#ifdef _SC_NPROCESSORS_ONLN
	proc_count = sysconf(_SC_NPROCESSORS_ONLN);
#endif

	if(proc_count == 1) {
		cout << "Partitioned scheduling test not applicable to single-core machine" << endl;
		return 0;
	}

	exec_slope = get_slope();
	if(exec_slope == 0) {
		cout << "Error: No slope found" << endl;
		return 0;
	}

	period.tv_sec = 0;
	period.tv_nsec = 0;

	if(prep_test())
		return 1;

	if(set_scheduler(sched, -1, mask3)) {
		cout << "Error: Unable to set scheduler" << endl;
		cout << "Are you running as root?" << endl;
	}

	test_val +=5;

	pthread_create(&t1, NULL, task1, NULL);
	pthread_create(&t3, NULL, task3, NULL);
	sleep(1);
	pthread_create(&t2, NULL, task2, NULL);
	pthread_create(&t4, NULL, task4, NULL);
	sleep(1);
	pthread_join(t2, NULL);
	pthread_join(t4, NULL);
	pthread_join(t1, NULL);
	pthread_join(t3, NULL);

	if(test_val == 10176266)
		cout << "Partitioned scheduling test successful" << endl;
	else
		cout << "Partitioned scheduling test failed: " << test_val << endl;

	return 0;
}




