#include "test.h"

unsigned long mask = 1;
struct timespec period;

void *task1(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	test_val *= 7;
	period.tv_sec = 2;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	test_val -= 9;
	burn_cpu(2000000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val -= 17;
	pthread_exit(NULL);
}

void *task2(void *p)
{
	int thread_id = gettid();
	sched_setaffinity(0, sizeof(mask), (cpu_set_t *) &mask);

	THREAD_OUTPUT("thread %d - start\n", thread_id);
	period.tv_sec = 1;
	begin_rtseg_selfbasic(RUN_PRIO, NULL, &period);

	test_val *= 11;

	//actual task block
	THREAD_OUTPUT("thread %d - burning cpu\n", thread_id);
	test_val -= 13;
	burn_cpu(2000000, exec_slope);
	end_rtseg_self(END_PRIO);
	THREAD_OUTPUT("thread %d - end\n", thread_id);
	test_val *= 15;
	pthread_exit(NULL);
}

int main(int argc, char* argv[])
{
	pthread_t t1, t2;
	sched = SCHED_RT_RMA;

	while ((c = getopt (argc, argv, optstring)) != -1)
	{
		switch (c) {
		case 'v' :
			verbose = true;
			break;
		case 'h' :
			cout << "A simple test for proper single-core scheduling behavior. Use -v for detailed output" << endl;
			return 0;
		}
	}

	exec_slope = get_slope();
	if(exec_slope == 0) {
		cout << "Error: No slope found" << endl;
		return 0;
	}

	period.tv_sec = 0;
	period.tv_nsec = 0;

	if(prep_test())
		return 1;

	if(set_scheduler(sched, -1, mask)) {
		cout << "Error: Unable to set scheduler" << endl;
		cout << "Are you running as root?" << endl;
	}

	test_val +=5;

	pthread_create(&t1, NULL, task1, NULL);
	sleep(1);
	pthread_create(&t2, NULL, task2, NULL);
	sleep(1);
	pthread_join(t2, NULL);
	pthread_join(t1, NULL);

	if(test_val == 7543)
		cout << "Single-core scheduling test successful" << endl;
	else
		cout << "Single-core scheduling test failed: " << test_val << endl;

	return 0;
}

