/* chronos/rtdvs/cc_edf.c
 *
 * CC-EDF Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2011 Virginia Tech Real Time Systems Lab
 */

#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <linux/time.h>
#include <linux/chronos_util.h>
#include <asm/current.h>

static int i=3;

//DECLARE_PER_CPU(struct cpufreq_policy *, cpufreq_cpu_data);

struct rt_info* sched_cc_edf(struct list_head *head, int flags)
{       
         int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p;
	 struct rt_info *task=NULL;
         int flag=0;
         long task_full_load=0;
         long task_prev_load=0;
         static long total_u_prev=0;
         policy=per_cpu(cpufreq_cpu_data,cpu);

         p=current;
         task = &(p->rtinfo);
         
         struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);

         flag=!list_empty(&task->task_list[0]);

   
          if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
          
         total_u =best->util_taskset;

     /*if scheduler invoked from beginrtseg*/
         if((flag==1)&&(task->flag_begin_end_check!=100)){

          task_full_load = (task->exec_time * 100) / ( (task->period.tv_sec * MILLION) + (task->period.tv_nsec/THOUSAND) );
              if(task->prev_load==0)
                    task->prev_load=task_full_load;
 
              if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
            
              total_u= total_u_prev - task->prev_load + task_full_load; 
              trace_printk("Scheduler invoked from beginrtseg\n");
              trace_printk(" task->load=%ld\n",task->load ); 
              trace_printk(" task_full_load=%ld\n",task_full_load );
              trace_printk(" task->prev_load=%ld\n",task->prev_load );
               trace_printk(" total_u=%ld\n",total_u );   
               trace_printk("task->");
              if(total_u>(best->util_taskset))total_u=best->util_taskset;
         }

      /*if scheduler invoked from endrtseg*/
         if((task->flag_begin_end_check==100)&&(flag!=1)){
                trace_printk("Scheduler invoked from endrtseg\n");
                if(total_u_prev==0)
                    total_u_prev=best->util_taskset; 
            task_full_load = (task->exec_time * 100) / ( (task->period.tv_sec * MILLION) + (task->period.tv_nsec/THOUSAND) );
          /*
                if(total_u_prev<=57)
                    task->load =(57*task->load)/100;
                if((total_u_prev> 57) && (total_u_prev<= 76))
                    task->load=(76*task->load)/100;
          */
            
                 task->load= (task->total_util)*(task->load)/100;
                task->prev_load=task->load;
                total_u = total_u_prev - task_full_load + task->load;        
                trace_printk(" task->load=%ld\n",task->load ); 
                trace_printk(" task_full_load=%ld\n",task_full_load ); 
                 trace_printk(" total_u=%ld\n",total_u ); 
                  if(total_u>(best->util_taskset))total_u=best->util_taskset;
         }
         
          /*if scheduler invoked from any other than chronos process*/
           if((task->flag_begin_end_check!=100)&&(flag!=1)){
             if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
               total_u= total_u_prev;
             if(total_u>(best->util_taskset))total_u=best->util_taskset;
         }  
         
       
         total_u_prev=total_u;

     //a trace_printk(" best->max_util=%d\n", best->max_util);
        if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1330000,CPUFREQ_RELATION_H);
              best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              best->total_util=61;
        }
        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
                best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                  best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
               best->total_util=100;
        }

	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}
struct rt_sched_local cc_edf = {
	.base.name = "CC_EDF",
	.base.id = SCHED_RT_CC_EDF,
	.flags = 0,
	.schedule = sched_cc_edf,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(cc_edf.base.list)
};

static int __init cc_edf_init(void)
{
	return add_local_scheduler(&cc_edf);
}
module_init(cc_edf_init);

static void __exit cc_edf_exit(void)
{
	remove_local_scheduler(&cc_edf);
}
module_exit(cc_edf_exit);

MODULE_DESCRIPTION("CC_EDF Single-Core Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");

