/* chronos/rtdvs/hs.c
 *
 * HS Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Matthew Dellinger, mdelling@vt.edu
 *
 * Copyright (C) 2009-2010 Virginia Tech Real Time Systems Lab
 */

#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <linux/time.h>
#include <linux/chronos_util.h>
#include <asm/current.h>
#include <linux/sched.h>
#include <linux/chronos_sched.h>

static int i=3;

//DECLARE_PER_CPU(struct cpufreq_policy *, cpufreq_cpu_data);

unsigned long max_blk_sec_func( struct rt_info *best_per)
{
            struct rt_info *it=NULL;
             it= best_per;
            long max_blk_sec=0;
           
              do{
                         it = it->list[0].next;
                     //      trace_printk("it->locked_usage = %ld\n",it->locked_usage);
                        	if( max_blk_sec < it->locked_usage)max_blk_sec=it->locked_usage;     		      
 	
       	           } while(it != best_per);

     return max_blk_sec;

}


/*
Test Speed( )
H = 0;
utilization = 0
for i = 1 to n //(P1 ≤ P2 ≤ . . . ≤ Pn )
utilization + = Ei /Pi ;

speed = utilization +max{Gj |Pi <Pj }/Pi;
H = max(speed, H);
end for
return H;

*/
static int prev_high_speed;
struct rt_info* sched_hs(struct list_head *head, int flags)
{       
         int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p,*p1;
	 struct rt_info *task=NULL;
         struct rt_info *task1=NULL;
         int flag=0;
         long task_full_load=0;
         long task_prev_load=0;
         static long total_u_prev=0;
         struct mutex_data *mutex_k;
         policy=per_cpu(cpufreq_cpu_data,cpu);
         long max_blk_sec;
         //int prev_high_speed;

        struct list_head *curr;
        struct rt_info *best_per = NULL, *last_per = NULL;
        int utilization, speed, high_speed;
         struct rt_info *prev_task=NULL;
//	struct rt_info *best_dead = NULL, *best_dead_old = NULL;

         p=current;
         task = &(p->rtinfo);
         struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);
         flag=!list_empty(&task->task_list[0]);

         if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
          
         total_u =best->util_taskset;

         mutex_k=best->mutex0;
   
        list_for_each(curr, head) {
		it = list_entry(curr, struct rt_info, task_list[0]);
		initialize_lists(it);

	if(check_task_failure(it, flags))
			return it;
              
          }
                
          if(best->mutex0->owner!=0){
                        p1=find_task_by_vpid(mutex_k->owner);
                        task1=&(p1->rtinfo);
                        best=task1;
                  }
      
        
         total_u = best->high_freq;
         

      trace_printk(" total_u=%d\n", total_u);
        if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1380000,CPUFREQ_RELATION_H);
              best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              best->total_util=61;
        }

        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
                best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                  best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
               best->total_util=100;
        }

	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}
struct rt_sched_local hs = {
	.base.name = "HS",
	.base.id = SCHED_RT_HS,
	.flags = 0,
	.schedule = sched_hs,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(hs.base.list)
};

static int __init hs_init(void)
{
	return add_local_scheduler(&hs);
}
module_init(hs_init);

static void __exit hs_exit(void)
{
	remove_local_scheduler(&hs);
}
module_exit(hs_exit);

MODULE_DESCRIPTION("HS Single-Core Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");

