/* laedf.c
 *
 * LAEDF Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2010 Virginia Tech Real Time Systems Lab
 */
// task->prev freq = task->total_util
// task->task_time_prev_upd = task->load
// task->task_time_prev_adj = task->prev_load
// task->prev_count_for_cycles_div = task->flag_check_rt_seg

#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <linux/time.h>
#include <linux/chronos_util.h>




static long calc_left_laedf(struct rt_info *task)
{
	 long left = 0;
  

        
	// unsigned long task_time_updated = task_time(task)- task->load;//0.9
          unsigned long task_time_adjusted= ((task->total_util)*task_time(task))/100;
               
          ///     trace_printk("task_time_updated=%ld\n",task_time_updated); 
               trace_printk("task_time_adjusted=%ld\n",task_time_adjusted); 
               trace_printk("task->load=%ld\n",task->load);

          //  task->load = task->load + task_time_updated;// 0.9         
             
               left = task->exec_time- task_time_adjusted;
     
          
	//left = task->exec_time*(task->count_for_cycles_div)- task->prev_load;
          task->flag_check_rtseg= task->count_for_cycles_div;

        trace_printk("task->task_time_prev_upd=%ld\n",task->load); 
        trace_printk("task->task_time_prev_adj=%ld\n",task->prev_load);  
        trace_printk("task->count_for_cycles_div=%ld\n",task->count_for_cycles_div);
        trace_printk("task->exec_time=%ld\n",task->exec_time);
        trace_printk("task_time(task)=%ld\n",task_time(task));
        trace_printk("left=%ld\n",left);
	//left = task->exec_time - task_no_exec;
	return (left <= 0) ? 0 : left;
         // return left;
}

static long update_left_laedf(struct rt_info *task)
{
	long left = 0;

	left = calc_left_laedf(task);
	long_to_timespec(left, &(task->left));
	return left;
}

static long total_u_prev=0;
DECLARE_PER_CPU(struct cpufreq_policy *, cpufreq_cpu_data);

static int defer(struct list_head *head){

      long s=0;
      long x;
      long it_full_load;
       struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);
      long total_u=best->util_taskset;
      struct list_head *curr;  
      struct rt_info *it;
      long x_var;
      long total_u_var=0;    
      long deadline_difference;
      long deadline_long; 
      long task_left_long;
 
     list_for_each_prev(curr, head) {

	   it = list_entry(curr, struct rt_info, task_list[0]);
           deadline_difference = timespec_to_long(&(it->deadline))-timespec_to_long(&(best->deadline));

              if(deadline_difference!=0){

		         deadline_long=(it->deadline.tv_sec * MILLION) + (it->deadline.tv_nsec/THOUSAND);
		         it_full_load= (it->exec_time * 100) / ( (it->period.tv_sec * MILLION) + (it->period.tv_nsec/THOUSAND) );
		         total_u= total_u - it_full_load;
		         task_left_long=update_left_laedf(it);
		         x_var = (100-total_u)*(deadline_difference)/100;
                         trace_printk("x_var=%ld\n",x_var);
		         x = timespec_to_long(&(it->left)) - x_var;
                          trace_printk("x_before=%ld\n",x);
		          if(x<0)x=0;
                           trace_printk("x_after=%ld\n",x);
		         total_u_var = 100*(timespec_to_long(&(it->left))-x)/deadline_difference;
                          trace_printk("total_u_var=%ld\n",total_u_var);
                          total_u = total_u + total_u_var;
                          trace_printk("total_u=%ld\n",total_u);
              }
              else {
                         task_left_long=update_left_laedf(it);
	                 x= timespec_to_long(&(it->left));
	                 if(x<0)x=0;
              }
   
          // total_u = total_u + total_u_var;
           trace_printk("total_u inside the loop=%ld",total_u );
           s=s+x;
           trace_printk("s=%ld\n",s);
      }
       
     trace_printk("s_total=%ld\n",s);
     struct timespec curr_time = current_kernel_time();
     
     trace_printk("curr_time in long=%ld\n",timespec_to_long(&(curr_time)));
     
     if((timespec_to_long(&(best->deadline))-timespec_to_long(&(curr_time)))==0)
                    total_u=100*s;
    else
       total_u =100* s/(timespec_to_long(&(best->deadline))-timespec_to_long(&(curr_time)));
      
         trace_printk("total_u=%ld\n",total_u);
          return total_u;
         

}
//long_to_timespec(left, &(task->left));
struct rt_info* sched_laedf(struct list_head *head, int flags)
{
         int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p;
	 struct rt_info *task=NULL;
         int flag=0;
         long task_full_load=0;
         long task_prev_load=0;
        static long total_u_prev=0;
         policy=per_cpu(cpufreq_cpu_data,cpu);
        struct list_head *curr;  

         p=current;
         task = &(p->rtinfo);
         
         //task->count_for_cycles
          list_for_each(curr, head) {
              it = list_entry(curr, struct rt_info, task_list[0]);
                         if((it->total_util)==0){
                           it->total_util=55;
                        }
           }
   
         struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);

         flag=!list_empty(&task->task_list[0]);

          if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
          
         total_u =best->util_taskset;

    
         if((flag==1)&&(task->flag_begin_end_check!=100)){
              
              trace_printk("Scheduler invoked from beginrtseg\n");
               update_left_laedf(task);
               trace_printk("task->left in begin_rt_seg=%ld\n",timespec_to_long(&task->left));
               long_to_timespec(task->exec_time,&(task->left));
             total_u=defer(head);
         }

     
         if(task->flag_begin_end_check==100){
           update_left_laedf(task);
       trace_printk("task->left in end_rt_seg=%ld\n",timespec_to_long(&task->left));
              zero_ts(&(task->left));
             total_u=defer(head);    
         }
         
         
           if((task->flag_begin_end_check!=100)&&(flag!=1)){
             if(total_u_prev==0)
                    total_u_prev=best->util_taskset;
               total_u= total_u_prev;
           //  if(total_u>(best->max_util))total_u=best->max_util;
         }  
        
         
         total_u_prev=total_u;

        

     trace_printk(" total_u=%d\n", total_u);
          if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1330000,CPUFREQ_RELATION_H);
              best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              best->total_util=61;
        }
        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
                best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                  best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
               best->total_util=100;
        }

	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}

struct rt_sched_local laedf = {
	.base.name = "LAEDF",
	.base.id = SCHED_RT_LAEDF,
	.flags = 0,
	.schedule = sched_laedf,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(laedf.base.list)
};

static int __init laedf_init(void)
{
	return add_local_scheduler(&laedf);
}
module_init(laedf_init);

static void __exit laedf_exit(void)
{
	remove_local_scheduler(&laedf);
}
module_exit(laedf_exit);

MODULE_DESCRIPTION("LAEDF Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");

