/* snowdon_min.c
 *
 * SNOWDON_MIN Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2010 Virginia Tech Real Time Systems Lab
 */


#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <asm/current.h>

struct rt_info* sched_snowdon_min(struct list_head *head, int flags)
{
	 int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p;
	 struct rt_info *task=NULL;
         int flag=0;
         long unused_time;
         long left;
         long total_u_prev=0;
         policy=per_cpu(cpufreq_cpu_data,cpu);
         long new_task_time=0;
         long new_task_time_best=0;
         
         p=current;
         task = &(p->rtinfo);
    
   struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);

     flag=!list_empty(&task->task_list[0]);
       
      total_u=best->util_taskset;
       total_u_prev=total_u;
 
   if(best->total_util==0)
        best->total_util=best->util_taskset;  

    /*if scheduler invoked from beginrtseg*/
     if((flag==1)&&(task->flag_begin_end_check==200)){
           
           trace_printk("scheduler invoked from beginrtseg");
           trace_printk(" best->util_taskset=%d\n", best->util_taskset);
           total_u= best->util_taskset;
           total_u_prev=total_u;
      }

      /*if scheduler invoked from endrtseg*/
     if((task->flag_begin_end_check==100)&&(flag!=1)){
          
          trace_printk("scheduler invoked from endrtseg");
       //   new_task_time =  task_time(task) - task->old_task_time;
          unused_time= task->budget - task_time(task);
          //  unused_time= task->budget - task->old_task_time;

         
          trace_printk("task->exec_time=%ld\n",task->exec_time);
          trace_printk("task_time(task)=%ld\n",task_time(task));
          trace_printk("task->old_task_time=%ld\n",task->old_task_time); 
          trace_printk("new_task_time=%ld\n",new_task_time);
          trace_printk("task->budget=%ld\n",task->budget);
          trace_printk("unused_time=%ld\n",unused_time);
          
       
               // task->old_task_time = task->old_task_time + new_task_time;
           
         
        //      new_task_time_best= task_time(best) - best->old_task_time;
              trace_printk("best->exec_time=%ld\n",best->exec_time);
              trace_printk("best->budget=%ld\n",best->budget);
              trace_printk("task_time(best)=%ld\n",task_time(best));
              trace_printk("best->old_task_time=%ld\n",best->old_task_time);
              trace_printk(" new_task_time_best=%ld\n", new_task_time_best);
              //best->old_task_time = best->old_task_time + new_task_time_best;

                 if (unused_time > 0){
                       	   	if(task_time(best)==0){
                                    trace_printk(" best->budget::BEFORE=%ld\n", best->budget);
                                    best->budget = best->budget + unused_time;
                           	   total_u = (best->util_taskset) * (best->exec_time)/(best->budget);
                                   //   total_u = (best->total_util) * (best->exec_time)/(best->budget);
                                    trace_printk(" best->budget::AFTER=%ld\n", best->budget);
                           	    trace_printk("total_u=%d\n",total_u);
                                    best->total_util=total_u; 
                       	  	 }
                       	     else{  
                                    //left = best->budget - new_task_time_best;
                                    left=best->budget - task_time(best);
                                    best->budget=best->budget - task_time(best) + unused_time;
                                    total_u = (best->util_taskset) * left/ best->budget;
                                   // total_u = (best->total_util) * left/ best->budget;
                                    trace_printk("best->budget=%ld\n",best->budget);
                                    trace_printk("left=%ld\n",left); 
                                    trace_printk("total_u=%d\n",total_u);
                                    best->total_util=total_u;
                                  }             
                   best->util_taskset=total_u;                 
                 }
            total_u_prev=total_u;
            //best->util_taskset=total_u;
      }
   

      /*if scheduler invoked from any other than chronos process*/
      if((task->flag_begin_end_check!=100)&&(flag!=1)){
            // total_u=total_u_prev;     
       }


     trace_printk(" total_u=%d\n", total_u);
          if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1330000,CPUFREQ_RELATION_H);
              best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              best->total_util=61;
        }
        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
                best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                  best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
               best->total_util=100;
        }
	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}

struct rt_sched_local snowdon_min = {
	.base.name = "SNOWDON_MIN",
	.base.id = SCHED_RT_SNOWDON_MIN,
	.flags = 0,
	.schedule = sched_snowdon_min,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(snowdon_min.base.list)
};

static int __init snowdon_min_init(void)
{
	return add_local_scheduler(&snowdon_min);
}
module_init(snowdon_min_init);

static void __exit snowdon_min_exit(void)
{
	remove_local_scheduler(&snowdon_min);
}
module_exit(snowdon_min_exit);

MODULE_DESCRIPTION("SNOWDON_MIN Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");

